;TIP1047.LSP:  DYN_VIEW.LSP     Change 3D View Dynamically     (C)1994, William Steeber

;   Internal error handler
(defun l_err (S)
   (if (/= S "Function cancelled")
      (princ (strcat "\nError: " S))
   )
   (command "ucs" "r" "tempucs")
   (command "view" "r" "tempview")
   (command "ucs" "d" "tempucs")
   (command "view" "d" "tempview")
   (setvar "coords" SCRD)
   (setvar "expert" SEXP)
   (grtext)
   (setvar "regenmode" SRM)
   (setq *error* O_ERR)
   (setvar "ucsicon" SUCSI)
   (setvar "cmdecho" SCE)
   (princ)
)
;   Begin polling keyboard
(defun do_get_input ()
   (setq CODE 0)
   (grtext -1 (strcat GRT_PRE DYN_INC))
   (while (/= code 13)     ; Until a return is keyed
      (setq code (car (cdr (grread nil 2 1))))
      (cond
         ((= code 43)    ; +
            (if (< (atoi DYN_INC) 45) (setq DYN_INC (itoa (1+ (atoi DYN_INC)))))
            (grtext -1 (strcat GRT_PRE DYN_INC))
         )
         ((= code 45)    ; -
            (if (> (atoi DYN_INC) 1) (setq DYN_INC (itoa (1- (atoi DYN_INC)))))
            (grtext -1 (strcat GRT_PRE DYN_INC))
         )
         ((or (= code 199) (= code 32))  ; Home, space
            (command "ucs" "r" "tempucs")
            (command "view" "r" "tempview")
         )
         ((= code 200)   ; Up cursor
            (command "ucs" "x" DYN_INC)
            (command "plan" "")
            (command "zoom" VW_SCL)
         )
         ((= code 203)   ; Left cursor
            (command "ucs" "y" DYN_INC)
            (command "plan" "")
            (command "zoom" VW_SCL)
         )
         ((= code 205)   ; Right cursor
            (command "ucs" "y" (strcat "-" DYN_INC))
            (command "plan" "")
            (command "zoom" VW_SCL)
         )
         ((= code 208)   ; Down cursor
            (command "ucs" "x" (strcat "-" DYN_INC))
            (command "plan" "")
            (command "zoom" VW_SCL)
         )
      )
   )
)
;   Program Main
(defun C:DYN_VIEW ()
   (setq SCE (getvar "cmdecho")
      SUCSI (getvar "ucsicon")
      SRM (getvar "regenmode")
      SCRD (getvar "coords")
      SEXP (getvar "expert")
      O_ERR *error*
      *error* L_ERR
   DYN_INC "10")
   (setvar "expert" 1)
   (setvar "coords" 0)
   (setvar "cmdecho" 0)
   (setvar "ucsicon" 0)
   (setvar "regenmode" 0)
   (graphscr)
   (if (= (getvar "tilemode") 0) (command "mspace"))
   (setq GRT_PRE "Dyn view increment angle = ")
   (if (tblsearch "ucs" "tempucs") (command "ucs" "d" "tempucs"))
   (command "ucs" "s" "tempucs")
   (command "view" "s" "tempview")
   (if (= (getvar "tilemode") 0)
      (setq PSVCRD (cdr (nth 0 (vports)))
      VW_SCL (strcat (rtos (/ (- (nth 0 (cdr (nth 1 PSVCRD))) (nth 0 (cdr (nth 0 PSVCRD)))) (getvar "viewsize")) 2 4) "xp"))
      (setq VW_SCL (rtos (/ (car (cdr (getvar "limmax"))) (getvar "viewsize")) 2 4))
   )
   (princ "\nDynamic view enabled...")
   (princ "\n(use cursor keys, home to reset, return to end)...")
   (do_get_input)
   (command "ucs" "r" "tempucs")
   (command "ucs" "d" "tempucs")
   (setvar "coords" SCRD)
   (grtext)
   (setvar "expert" SEXP)
   (setvar "regenmode" SRM)
   (setvar "ucsicon" SUCSI)
   (setvar "cmdecho" SCE)
   (setq *error* O_ERR)
   (princ)
); end dyn_view.lsp
